<template>
  <div>
    <h2>{{ heading }}</h2>

    <div class="mt-2">
      <v-text-field
        ref="firstElement"
        v-validate="'required|max:30'"
        :value="documentCity"
        @change="documentCity = $event"
        :counter="30"
        :error-messages="errors.collect('documentCity')"
        label="Miejsce dostarczenia wypowiedzenia (miasto)"
        data-vv-as="Miejsce dostarczenia wypowiedzenia"
        data-vv-name="documentCity"
        required
      ></v-text-field>

      <v-checkbox
        v-model="leftDocumentDateEmpty"
        @change="leftDocumentDateEmptyChange"
        label="Pozostaw pole Data dostarczenia dokumentu puste"
        type="checkbox"
        required
      ></v-checkbox>

      <v-menu
          ref="documentDateMenu"
          :close-on-content-click="false"
          v-model="documentDateMenu"
          :nudge-right="40"
          :return-value.sync="documentDate"
          lazy
          transition="scale-transition"
          offset-y
          full-width
          min-width="290px"
          :disabled="leftDocumentDateEmpty"
        >
        <v-text-field
          v-validate="'required'"
          slot="activator"
          v-model="documentDate"
          prepend-icon="event"
          :error-messages="errors.collect('documentDate')"
          label="Data dostarczenia dokumentu"
          data-vv-as="Data dostarczenia dokumentu"
          data-vv-name="documentDate"
          :disabled="leftDocumentDateEmpty"
          required
          readonly
        ></v-text-field>
        <v-date-picker v-model="documentDate" no-title scrollable v-if="!leftDocumentDateEmpty">
          <v-spacer></v-spacer>
          <v-btn flat color="primary" @click="documentDateMenu = false">Anuluj</v-btn>
          <v-btn flat color="primary" @click="$refs.documentDateMenu.save(documentDate)">OK</v-btn>
        </v-date-picker>
      </v-menu>

      <v-text-field
        v-validate="'required|max:30'"
        :value="agreementType"
        @change="agreementType = $event"
        :counter="30"
        :error-messages="errors.collect('agreementType')"
        label="Rodzaj umowy (np. o pracę)"
        data-vv-as="Rodzaj umowy"
        data-vv-name="agreementType"
        required
      ></v-text-field>

      <v-menu
        ref="agreementDateMenu"
        :close-on-content-click="false"
        v-model="agreementDateMenu"
        :nudge-right="40"
        :return-value.sync="agreementDate"
        lazy
        transition="scale-transition"
        offset-y
        full-width
        min-width="290px"
      >
        <v-text-field
          v-validate="'required'"
          slot="activator"
          v-model="agreementDate"
          prepend-icon="event"
          :error-messages="errors.collect('agreementDate')"
          label="Data zawarcia umowy"
          data-vv-as="Data zawarcia umowy"
          data-vv-name="agreementDate"
          required
          readonly
        ></v-text-field>
        <v-date-picker v-model="agreementDate" no-title scrollable>
          <v-spacer></v-spacer>
          <v-btn flat color="primary" @click="agreementDateMenu = false">Cancel</v-btn>
          <v-btn flat color="primary" @click="$refs.agreementDateMenu.save(agreementDate)">OK</v-btn>
        </v-date-picker>
      </v-menu>

      <v-text-field
        v-validate="'required|max:40'"
        :value="fullName"
        @change="fullName = $event"
        :counter="40"
        :error-messages="errors.collect('fullName')"
        label="Imię i nazwisko (odmienione, umowa zawarta pomiędzy firmą X, a ...)"
        data-vv-as="Imię i nazwisko"
        data-vv-name="fullName"
        required
      ></v-text-field>
    </div>
  </div>
</template>


<script>
export default {
  inject: ['parentValidator'],
  data() {
    return {
      heading: 'Inne dane',
      leftDocumentDateEmpty: false,
      lastPickedDocumentDate: '',
      documentDateMenu: false,
      agreementDateMenu: false,
    };
  },
  computed: {
    documentCity: {
      get() { return this.$store.getters['form/others/getDocumentCity']; },
      set(value) { this.$store.dispatch('form/others/setDocumentCity', value); },
    },
    documentDate: {
      get() { return this.$store.getters['form/others/getDocumentDate']; },
      set(value) { this.$store.dispatch('form/others/setDocumentDate', value); },
    },
    agreementType: {
      get() { return this.$store.getters['form/others/getAgreementType']; },
      set(value) { this.$store.dispatch('form/others/setAgreementType', value); },
    },
    agreementDate: {
      get() { return this.$store.getters['form/others/getAgreementDate']; },
      set(value) { this.$store.dispatch('form/others/setAgreementDate', value); },
    },
    fullName: {
      get() { return this.$store.getters['form/others/getFullName']; },
      set(value) { this.$store.dispatch('form/others/setFullName', value); },
    },
  },
  methods: {
    leftDocumentDateEmptyChange(checked) {
      if (checked) {
        this.lastPickedDocumentDate = this.documentDate;
        this.documentDate = '_'.repeat(20);
      } else {
        this.documentDate = this.lastPickedDocumentDate;
      }
    },
  },
  created() {
    this.$validator = this.parentValidator;
  },
  mounted() {
    this.$refs.firstElement.focus();
  },
};
</script>
